



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>优化设计提高sql类数据库的性能</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">优化设计提高sql类数据库的性能</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:21:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>前言</strong></p>
<p>在一个项目中，技术的统一性是最重要的，数据库的设计则是重点中的重点。NoSQL 是目前最流行的数据库，但是其实用性和功能性远不如sql数据库。</p>
<p>实际很多SQL数据库被诟病的性能问题大多是源于程序员的不合理设计，一个好的设计可以使sql类数据库提高几倍的性能。</p>
<p><strong>1.细节的优化</strong></p>
<p>字段尽量设置为not null 。</p>
<p>规范字段大小，越小越好。</p>
<p>表名规范前缀。</p>
<p>一个表尽量储存一个对象。</p>
<p>char永远比varchar更高效。</p>
<p>timestamp 比datetime小一倍。</p>
<p>避免字串ID。</p>
<p>单条查询最后用limit 1。</p>
<p>不用mysql内置函数，因为不会建立查询缓存。</p>
<p>使用ip而不是域名作为数据库的路径，避免dns解析。</p>
<p><strong>2.使用sql内置功能</strong></p>
<p>例如trigger，procedure，event...等等，可以有效减少后端代码的运用，但是不适合处理高触发的项目。</p>
<p><strong>3.选择适合的存储引擎</strong></p>
<p>最常见的就是InnoDB 与 MyISAM. 两者区别请自行百度。</p>
<p><strong>4.将数据保存至内存中</strong></p>
<p>从内存中读取数据，最大限度减少磁盘的操作，相关内容会在后面详细解释。</p>
<p><strong>5.提高磁盘读写速度</strong></p>
<p><strong>6.充分使用索引 INDEX</strong></p>
<div>
<pre class="prettyprint linenums">mysql&gt; DROP INDEX index_name ON tab;  //添加index<br />
mysql&gt; ALTER TABLE tab DROP INDEX index_name ; //删除index
</pre>
</div>
<p><strong>7.使用内存磁盘　　</strong></p>
<p>现在基础设施都过硬，所以可以将sql 目录迁移到内存磁盘上。</p>
<p><strong>8.读写分离设计</strong></p>
<p>随着系统变得越来越庞大，特别是当它们拥有很差的SQL时，一台数据库服务器通常不足以处理负载。但是多个数据库意味着重复，除非你对数据进行了分离。更一般地，这意味着建立主/从副本系统，其中程序会对主库编写所有的Update、Insert和Delete变更语句，而所有Select的数据都读取自从数据库（或者多个从数据库）。</p>
<p>尽管概念上很简单，但是想要合理、精确地实现并不容易，这可能需要大量的代码工作。因此，即便在开始时使用同一台数据库服务器，也要尽早计划在php中使用分离的DB连接来进行读写操作。如果正确地完成该项工作，那么系统就可以扩展到2台、3台甚至12台服务器，并具备高可用性和稳定性。</p>
<p><strong>9.使用memcache或者redis</strong></p>
<p>之前的博客有相关的介绍。</p>
<p><strong>10.SQL数据库分散式布局</strong></p>
<p>将数据库分散到多个服务器上，分担数据库工作压力。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96r1yv9.html">入门级：怎么使用C&num;进行套接字编程（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ev2rm9.html">在 Visual Studio 中打开编辑 cshtml 文件时出现错误：未能完成该操作 无效指针 的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xl6dg9.html">在ubuntu下利用minicom实现串口通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo1v2nq.html">关于在打包Jar文件时遇到的资源路径问题&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoj7l3q.html">css中的inline-block</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojoej1q.html">dom4j读取xml</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1y12yq.html">Centos7 编译安装Nginx 教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oxx318.html">asp&period;net core 同时添加Identity和Bearer认证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10zv09.html">查找数组中重复的唯一元素&plus;时间复杂度O（n）&plus;空间复杂度O（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r56rddq.html">Redis 集群知识点及命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1wgn9.html">oracle批量插入数据（测试）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1pydeq.html">U3D面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25l23vq.html">python XML文件解析：用ElementTree解析XML</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4zxwe9.html">第10章 网络安全（5）&lowbar;访问控制列表ACL</a>
		</li>
						<li><a href="https://www.batexi.com/a/960vkl39.html">SVN安装后bin中没有svn&period;exe，TortoiseSVN安装后bin目录中没有svn&period;exe；</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emnz0x9.html">LoadRunner常用函数汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g30mo4q.html">vSphere共享存储全配置流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zvpzmd9.html">5-EasyNetQ之Publish&lpar;黄亮翻译&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3v30eq.html">安装和使用nmon监测hadoop集群性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ode00xq.html">R语言数据管理（五）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpr33r9.html">canvas入门之时钟的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zolgwxq.html">使用tail命令实时查看日志文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/950ng7m8.html">Android自定义processor实现bindView功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjlnn28.html">ExtJs 带参数的MVC</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j6xlo8.html">uva11059（最大乘积）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzxe348.html">【日常学习】【IDA&ast;】codevs2449 骑士精神题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p47ky8.html">hdu  4869  Turn the pokers  （思维）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpd50j9.html">char a&lbrack;&rsqb; &equals; &amp;quot&semi;ab&bsol;0123&bsol;098&amp;quot&semi;&semi; 求a的长度</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdvx2k9.html">Python笔记&amp;&num;183&semi;第五章&mdash;&mdash; 列表（List） 的增删改查及其他方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk45rd8.html">翻译：CREATE DATABASE语句</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
